library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package pkg_exp_tbl is
  component exp_tbl_15 is
    port (x : in  std_logic_vector(4 - 1 downto 0);
          y : out std_logic_vector(7 - 1 downto 0));
  end component;
  -- tabule e ^ x - x - 1 avec 5 bits en entree, 1 en sortie
  -- le dernier bit de l'entree est le 8eme apres la virgule
  component exp_tbl_19 is
    port (x : in  std_logic_vector(4 downto 0);
          y : out std_logic_vector(0 downto 0));
  end component;
  -- tabule ln(e ^ x tronque a 8 bits) avec 14 bits en sortie
  component log_tbl_19 is
    port (x : in  std_logic_vector(4 downto 0);
          y : out std_logic_vector(13 downto 0));
  end component;
  -- tabule e ^ x - x - 1 avec 4 bits en entree, 3 en sortie
  -- le dernier bit de l'entree est le 5eme apres la virgule
  -- l'entree a en plus un bit de signe
  component exp_tbl_21 is
    port (x : in  std_logic_vector(4 downto 0);
          y : out std_logic_vector(2 downto 0));
  end component;
  -- tabule ln(e ^ x tronque a 5 bits) avec 18 bits en sortie
  component log_tbl_21 is
    port (x : in  std_logic_vector(4 downto 0);
          y : out std_logic_vector(17 downto 0));
  end component;
end package;

-- tables pour le composant exp_11
-- ===============================

-- tables pour le composant exp_15
-- ===============================

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity exp_tbl_15 is
  port ( x : in  std_logic_vector(3 downto 0);
         y : out std_logic_vector(6 downto 0) );
end entity;

architecture arch of exp_tbl_15 is
begin
  with x select
    y <= "0000000" when "0000",
         "0000001" when "0001",
         "0000010" when "0010",
         "0000101" when "0011",
         "0001000" when "0100",
         "0001101" when "0101",
         "0010010" when "0110",
         "0011001" when "0111",
         "0100000" when "1000",
         "0101001" when "1001",
         "0110010" when "1010",
         "0111101" when "1011",
         "1001000" when "1100",
         "1010101" when "1101",
         "1100010" when "1110",
         "1110001" when "1111",
         "-------" when others;
end architecture;

-- tables pour le composant exp_19
-- ===============================

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity exp_tbl_19 is
  port ( x : in  std_logic_vector(4 downto 0);
         y : out std_logic_vector(0 downto 0) );
end entity;

architecture arch of exp_tbl_19 is
begin
  with x select
    y <= "0" when "00000",
         "0" when "00001",
         "0" when "00010",
         "0" when "00011",
         "0" when "00100",
         "0" when "00101",
         "0" when "00110",
         "0" when "00111",
         "0" when "01000",
         "0" when "01001",
         "0" when "01010",
         "0" when "01011",
         "0" when "01100",
         "0" when "01101",
         "0" when "01110",
         "0" when "01111",
         "0" when "10000",
         "0" when "10001",
         "0" when "10010",
         "0" when "10011",
         "0" when "10100",
         "0" when "10101",
         "0" when "10110",
         "1" when "10111",
         "1" when "11000",
         "1" when "11001",
         "1" when "11010",
         "1" when "11011",
         "1" when "11100",
         "1" when "11101",
         "1" when "11110",
         "1" when "11111",
         "-" when others;
end architecture;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity log_tbl_19 is
  port ( x : in  std_logic_vector(4 downto 0);
         y : out std_logic_vector(13 downto 0) );
end entity;

architecture arch of log_tbl_19 is
begin
  with x select
    y <= "00000000000000" when "00000",
         "00000000100000" when "00001",
         "00000001111111" when "00010",
         "00000100011110" when "00011",
         "00000111111011" when "00100",
         "00001100010110" when "00101",
         "00010001101110" when "00110",
         "00011000000100" when "00111",
         "00011111010110" when "01000",
         "00100111100101" when "01001",
         "00110000101111" when "01010",
         "00111010110101" when "01011",
         "01000101110101" when "01100",
         "01010001110000" when "01101",
         "01011110100100" when "01110",
         "01101100010011" when "01111",
         "01111010111010" when "10000",
         "10001010011010" when "10001",
         "10011010110010" when "10010",
         "10101100000010" when "10011",
         "10111110001010" when "10100",
         "11010001001001" when "10101",
         "11100100111110" when "10110",
         "00001111001011" when "10111",
         "00100101100010" when "11000",
         "00111100101111" when "11001",
         "01010100101111" when "11010",
         "01101101100101" when "11011",
         "10000111001110" when "11100",
         "10100001101011" when "11101",
         "10111100111011" when "11110",
         "11011000111110" when "11111",
         "--------------" when others;
end architecture;

-- tables pour le composant exp_21
-- ===============================

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity exp_tbl_21 is
  port ( x : in  std_logic_vector(4 downto 0);
         y : out std_logic_vector(2 downto 0) );
end entity;

architecture arch of exp_tbl_21 is
begin
  with x select
    y <= "011" when "11111",
         "011" when "11110",
         "010" when "11101",
         "010" when "11100",
         "001" when "11011",
         "001" when "11010",
         "001" when "11001",
         "001" when "11000",
         "000" when "10111",
         "000" when "10110",
         "000" when "10101",
         "000" when "10100",
         "000" when "10011",
         "000" when "10010",
         "000" when "10001",
         "000" when "10000",
         "000" when "00000",
         "000" when "00001",
         "000" when "00010",
         "000" when "00011",
         "000" when "00100",
         "000" when "00101",
         "000" when "00110",
         "000" when "00111",
         "001" when "01000",
         "001" when "01001",
         "001" when "01010",
         "010" when "01011",
         "010" when "01100",
         "011" when "01101",
         "011" when "01110",
         "100" when "01111",
         "---" when others;
end architecture;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity log_tbl_21 is
  port ( x : in  std_logic_vector(4 downto 0);
         y : out std_logic_vector(17 downto 0) );
end entity;

architecture arch of log_tbl_21 is
begin
  with x select
    y <= "010101110011101110" when "11111",
         "000001010010001010" when "11110",
         "100001010010001010" when "11101",
         "001111010100101001" when "11100",
         "101111010100101001" when "11011",
         "011111101011111010" when "11010",
         "010010001010101110" when "11001",
         "000110100101100010" when "11000",
         "100110100101100010" when "10111",
         "011100110010001110" when "10110",
         "010100100111110111" when "10101",
         "001101111110100000" when "10100",
         "001000101111000111" when "10011",
         "000100110011011000" when "10010",
         "000010000101100110" when "10001",
         "000000100000101100" when "10000",
         "000000000000000000" when "00000",
         "000000011111010110" when "00001",
         "000001111010111010" when "00010",
         "000100001111001011" when "00011",
         "000111011000111110" when "00100",
         "001011010101010111" when "00101",
         "010000000001101000" when "00110",
         "010101011011010011" when "00111",
         "000010001101110100" when "01000",
         "001001100010100011" when "01001",
         "010001011100011101" when "01010",
         "000010111001000010" when "01011",
         "001100011000101000" when "01100",
         "000000110011011100" when "01101",
         "001011101100001001" when "01110",
         "000010101110010110" when "01111",
         "------------------" when others;
end architecture;

